<?php

/**                               ______________________________________________
*                          o O   |                                              |
*                 (((((  o      <    Generated with Cook Self Service  V1.5.2   |
*                ( o o )         |______________________________________________|
* --------oOOO-----(_)-----OOOo---------------------------------- www.j-cook.pro --- +
* @version		1.0.0
* @package		DataDownload
* @subpackage	Datasets
* @copyright	Copyright 2012, All rights reserved
* @author		Andy Hickey - http://www.netamity.com - andrew@netamity.com
* @license		GPL2
*
* /!\  Joomla! is free software.
* This version may have been modified pursuant to the GNU General Public License,
* and as distributed it includes or is derivative of works licensed under the
* GNU General Public License or other free or open source software licenses.
*
*             .oooO  Oooo.     See COPYRIGHT.php for copyright notices and details.
*             (   )  (   )
* -------------\ (----) /----------------------------------------------------------- +
*               \_)  (_/
*/



// no direct access
defined('_JEXEC') or die('Restricted access');


/**
* Datadownload Table class
*
* @package		Joomla
* @subpackage	Datadownload
*
*/
class TableDataset extends JTable
{

	/**
	 * Primary Key
	 *
	 * @var int
	 */
	var $id = null;

	/**
	 * @var string
	 */
	var $attribs = null;

	/**
	 * @var string
	 */
	var $title = null;
	/**
	 * @var bool
	 */
	var $add_date = null;
	/**
	 * @var bool
	 */
	var $wizard = null;
	/**
	 * @var string
	 */
	var $table_name = null;
	/**
	 * @var string
	 */
	var $return_fields = null;
	/**
	 * @var string
	 */
	var $where_field = null;
	/**
	 * @var string
	 */
	var $where_value = null;
	/**
	 * @var string
	 */
	var $and_where = null;
	/**
	 * @var string
	 */
	var $and_where_value = null;
	/**
	 * @var string
	 */
	var $group = null;
	/**
	 * @var string
	 */
	var $order = null;
	/**
	 * @var bool
	 */
	var $order_asc = null;
	/**
	 * @var string
	 */
	var $order2 = null;
	/**
	 * @var bool
	 */
	var $order_2_asc = null;
	/**
	 * @var string
	 */
	var $custom = null;
	/**
	 * @var string
	 */
	var $randkey = null;
	/**
	 * @var bool
	 */
	var $show_titles = null;
	/**
	 * @var string
	 */
	var $field_titles = null;






	/**
	* Constructor
	*
	* @param object Database connector object
	*
	*/
	function __construct(& $db)
	{
		parent::__construct('#__datadownload_datasets', 'id', $db);
	}




	/**
	* Overloaded bind function
	*
	* @acces public
	* @param array $hash named array
	* @return null|string	null is operation was satisfactory, otherwise returns an error
	* @see JTable:bind
	*
	*/
	function bind($src, $ignore = array())
	{

		if (isset($src['attribs']) && is_array($src['attribs']))
		{
			$registry = new JRegistry;
			$registry->loadArray($src['attribs']);
			$src['attribs'] = (string) $registry;
		}

		return parent::bind($src, $ignore);
	}

	/**
	 * Overloaded check method to ensure data integrity
	 *
	 * @access public
	 * @return boolean True on success
	 * @see JTable:check
	 */
	function check()
	{
		$valid = true;

		$filter = new JFilterInput(array(), array(), 0, 0);
		$this->title = $filter->clean($this->title, 'STRING');
		$this->add_date = $filter->clean($this->add_date, 'BOOL');
		$this->wizard = $filter->clean($this->wizard, 'BOOL');
		$this->table_name = $filter->clean($this->table_name, 'STRING');
		$this->return_fields = $filter->clean($this->return_fields, 'STRING');
		$this->where_field = $filter->clean($this->where_field, 'STRING');
		$this->where_value = $filter->clean($this->where_value, 'STRING');
		$this->and_where = $filter->clean($this->and_where, 'STRING');
		$this->and_where_value = $filter->clean($this->and_where_value, 'STRING');
		$this->group = $filter->clean($this->group, 'STRING');
		$this->order = $filter->clean($this->order, 'STRING');
		$this->order_asc = $filter->clean($this->order_asc, 'BOOL');
		$this->order2 = $filter->clean($this->order2, 'STRING');
		$this->order_2_asc = $filter->clean($this->order_2_asc, 'BOOL');
		$this->custom = $filter->clean($this->custom, 'STRING');
		$this->randkey = $filter->clean($this->randkey, 'STRING');
		$this->show_titles = $filter->clean($this->show_titles, 'BOOL');
		$this->field_titles = $filter->clean($this->field_titles, 'STRING');










		return $valid;
	}
}
